#include <string.h>
#include "quake_ipc.h"

extern "C" void *new_malloc(int size)
{
	while(quake_ipc_7to9->message == 0xffffffff);
	
	unsigned int result;
	quake_ipc_7to9->message_type = kMalloc;
	*(unsigned int *)quake_ipc_7to9_buf = size;
	quake_ipc_7to9->message = 0xffffffff;
	
	while (quake_ipc_7to9->message_type == kMalloc);
	
	if (quake_ipc_7to9->message_type != kMallocResponse)
	{
		ARM7_PRINT("should have received a malloc response!\n");
		ARM7_HALT();
	}
	
	result = *(unsigned int *)quake_ipc_7to9_buf;
	
	while(quake_ipc_7to9->message == 0xffffffff);
	
	ARM7_PRINT("malloc ok\n");
	
	return (void *)result;
}

extern "C" void new_free(void *ptr)
{
	while(quake_ipc_7to9->message == 0xffffffff);
	
	unsigned int result;
	quake_ipc_7to9->message_type = kFree;
	*(unsigned int *)quake_ipc_7to9_buf = (unsigned int)ptr;
	quake_ipc_7to9->message = 0xffffffff;
	
	while(quake_ipc_7to9->message == 0xffffffff);
}
